"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const construct_1 = __importDefault(require("./construct"));
const language_1 = require("../enums/language");
const language_2 = require("./language");
class Compiler {
    constructor() {
        this.languages = language_1.Language;
        (0, construct_1.default)();
    }
    compile({ language, code, input, timeout }) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const response = yield language_2.Languages[language].Run(code, input || '', timeout || 0);
                return {
                    data: response.stdout || response.stderr,
                };
            }
            catch (e) {
                return {
                    error: (e === null || e === void 0 ? void 0 : e.message) || 'error'
                };
            }
        });
    }
}
exports.default = Compiler;
