/* eslint-disable @typescript-eslint/await-thenable */
/* eslint-disable @typescript-eslint/require-await */
import { which, echo, exec, cd } from "shelljs";
import { Comands } from "../../../enums/comands";
import { Message } from "../../../enums/message";
import * as fs from "fs";
const Run = async (code, input, timeout) => {
    const process = cd(`/${Comands.Dir}/${Comands["DirC++"]}`);
    process.exec("tsp rm -rf *");
    process.exec(`tsp touch ./main.sh`);
    process.exec(`tsp touch ./main.cpp`);
    const options = {};
    if (timeout) {
        options.timeout = timeout;
    }
    const commands = [
        `
  echo ${JSON.stringify(code)} > ./main.cpp && echo ${JSON.stringify(input)} > ./input.txt
  `,
        `\n`,
        "g++ ./main.cpp",
        `\n`,
    ];
    if (input) {
        commands.push("./a.out  < input.txt > output.txt");
    }
    else {
        commands.push("./a.out  > output.txt");
    }
    commands.push(`\n`);
    commands.push("rm -rf a.out && rm -rf input.txt && rm -rf main.cpp");
    commands.push(`\n`);
    commands.push("cat output.txt");
    await fs.writeFileSync(`/${Comands.Dir}/${Comands["DirC++"]}/main.sh`, commands.join(" "), "utf8");
    const id_start = await new Promise((resolve, reject) => {
        return process.exec(`tsp sh ./main.sh`, { ...options, async: true }, (codes, stdout, stderr) => {
            if (!codes && !stderr) {
                resolve(+stdout);
            }
            else {
                reject(stderr);
            }
        });
    });
    if (typeof id_start !== "number") {
        throw new Error("not get proccess id");
    }
    const execute = await new Promise((resolve) => {
        return process.exec(`tsp -c ${id_start}`, { ...options, async: true }, (_, stdout, stderr) => {
            process.exec(`tsp -k ${id_start}`);
            resolve({
                stdout,
                stderr,
            });
        });
    });
    process.exec(Comands.KillFinished);
    return execute;
};
const Install = () => {
    if (!which(Comands["C++"])) {
        exec(Comands["C++Install"]);
    }
    if (!which(Comands["C++"])) {
        echo(Message["C++"]);
    }
    exec(`tsp mkdir -p /${Comands.Dir}/${Comands["DirC++"]}/`);
    exec(Comands.KillTs);
};
export { Run, Install };
