import __construct from "./construct";
import { Language } from "../enums/language";
import { Languages } from "./language";
class Compiler {
    languages = Language;
    constructor() {
        __construct();
    }
    async compile({ language, code, input, timeout }) {
        try {
            const response = await Languages[language].Run(code, input || '', timeout || 0);
            return {
                data: response.stdout || response.stderr,
            };
        }
        catch (e) {
            return {
                error: e?.message || 'error'
            };
        }
    }
}
export default Compiler;
